unit hiImg_Copy_Ex; //  mod by Aziz (18.4.2023)

interface

uses Windows,Kol,Share,Img_Draw,Debug;
            {$I share.inc}
type
  THIImg_Copy_Ex = class(THIDraw2PR)
   private
    dest:PBitmap;
   public
    _prop_X:integer;
    _prop_Y:integer;
    _prop_Width:integer;
    _prop_Height:integer;
    _prop_DrawSource:byte;
    _prop_FillStyle:boolean; 
    _prop_BackgroundColor: integer;
    _data_BackgroundColor: THI_Event;
    
    
    _data_Height:THI_Event;
    _data_Width:THI_Event;
    _data_Y:THI_Event;
    _data_X:THI_Event;
    _data_Source:THI_Event;
    _data_Pattern:THI_Event;
    _event_onCopy:THI_Event;

    destructor Destroy; override;
    procedure _work_doCopy0(var _Data:TData; Index:word);
    procedure _work_doCopy1(var _Data:TData; Index:word);
    procedure _work_doFillStyle(var _Data:TData; Index:word);
    procedure _var_Result(var _Data:TData; Index:word);
   
  end;

implementation

destructor THIImg_Copy_Ex.Destroy;
begin
   if Assigned(dest) then dest.free;
   inherited;
end;


procedure THIImg_Copy_Ex._work_doFillStyle;
begin
   _prop_FillStyle := ReadBool(_Data);
end;


procedure THIImg_Copy_Ex._work_doCopy0; //Bitmap
var   bmp:PBitmap;
      x,y,w,h:integer;
      
      br: HBRUSH;
      sColor,bgColor: TColor;
      Pattern: PBitmap;  
       


begin


          

   bmp := ReadBitmap(_Data,_data_Source,nil);
   if (bmp = nil) or bmp.Empty then exit;
   x := ReadInteger(_Data,_data_X,_prop_X);
   y := ReadInteger(_Data,_data_Y,_prop_Y);
   w := ReadInteger(_Data,_data_Width,_prop_Width);
   h := ReadInteger(_Data,_data_Height,_prop_Height);
   if Assigned(dest) then dest.free;
   dest := NewBitmap(w,h);
   if dest.Empty then exit;
   
 
   
   //  mod by Aziz (18.4.2023)
  pDC := dest.Canvas.Handle; 
  sColor := Color2RGB(ReadInteger(_Data,_data_Color,_prop_Color));
  bgColor := Color2RGB(ReadInteger(_Data,_data_BackgroundColor,_prop_BackgroundColor));

   if _prop_FillStyle then
   begin
     Pattern := ReadBitmap(_Data,_data_Pattern);
     if not Assigned(Pattern) or Pattern.Empty then
       br := GetStockObject(NULL_BRUSH)
     else
       br := CreatePatternBrush(Pattern.Handle);
   end
   else
   begin
     if _prop_Style = bsSolid then
        br := CreateSolidBrush(sColor)
     else if _prop_Style = bsClear then
        br := GetStockObject(NULL_BRUSH)
     else
       begin
         //SetBkMode(pDC, TRANSPARENT);    // TRANSPARENT Opaque 
         SetBkColor(pDC, bgColor);
         br := CreateHatchBrush(ord(_prop_Style) - 2, sColor);
       end;
   end;       
   
  SelectObject(pDC,br); 
  PatBlt(pDC,0,0,w,h,PATCOPY);
  BitBlt(pDC, 0, 0, w, h, bmp.Canvas.Handle, X, Y, SRCCOPY);
 
    DeleteObject(br);
    // end of mod by Aziz (18.4.2023)

  //ImgReleaseDC;
  _hi_onEvent(_event_onCopy, dest);
 
   
end;

procedure THIImg_Copy_Ex._work_doCopy1; //Handle
var   DC:HDC;
      Wnd:HWND;
      x,y,w,h:integer;
      br: HBRUSH;
      sColor,bgColor: TColor;
      Pattern: PBitmap; 
begin
   Wnd := ReadInteger(_Data,_data_Source,0);
   DC := GetDC(wnd);
   x := ReadInteger(_Data,_data_X,_prop_X);
   y := ReadInteger(_Data,_data_Y,_prop_Y);
   w := ReadInteger(_Data,_data_Width,_prop_Width);
   h := ReadInteger(_Data,_data_Height,_prop_Height);
   if Assigned(dest) then dest.free;
   dest := NewBitmap(w,h);
   if dest.Empty then exit;         
   BitBlt(dest.Canvas.Handle, 0, 0, w, h, DC, X, Y, SRCCOPY);
   
   
      //  mod by Aziz (18.4.2023)
  pDC := dest.Canvas.Handle; 
  sColor := Color2RGB(ReadInteger(_Data,_data_Color,_prop_Color));
  bgColor := Color2RGB(ReadInteger(_Data,_data_BackgroundColor,_prop_BackgroundColor));

   if _prop_FillStyle then
   begin
     Pattern := ReadBitmap(_Data,_data_Pattern);
     if not Assigned(Pattern) or Pattern.Empty then
       br := GetStockObject(NULL_BRUSH)
     else
       br := CreatePatternBrush(Pattern.Handle);
   end
   else
   begin
     if _prop_Style = bsSolid then
        br := CreateSolidBrush(sColor)
     else if _prop_Style = bsClear then
        br := GetStockObject(NULL_BRUSH)
     else
       begin
         //SetBkMode(pDC, TRANSPARENT);    // TRANSPARENT Opaque 
         SetBkColor(pDC, bgColor);
         br := CreateHatchBrush(ord(_prop_Style) - 2, sColor);
       end;
   end;       
   
  SelectObject(pDC,br); 
  PatBlt(pDC,0,0,w,h,PATCOPY);
  BitBlt(pDC, 0, 0, w, h, bmp.Canvas.Handle, X, Y, SRCCOPY);
 
    DeleteObject(br);
   // end of mod by Aziz (18.4.2023)
   
   
   
   ReleaseDC(Wnd,dc);
   _hi_onEvent(_event_onCopy, dest);
end;

procedure THIImg_Copy_Ex._var_Result;
begin
   if (dest = nil) or dest.Empty then exit;
   dtBitmap(_Data, dest);
end;

end.
