unit hiImg_Rotate_Ex; {       }   //  mod by Aziz (18.4.2023)

interface

uses Windows, Kol, Share, Img_Draw, Debug;
        {$I share.inc} 
type
  THIImg_Rotate_Ex = class(THIDraw2PR)     // TDebug
  private
    Bitmap: PBitmap;
    RotateBmp: PBitmap;
  public
    _prop_angle: real;
    _prop_BackgroundColor: integer;
    _data_Bitmap: THI_Event;
    _data_angle: THI_Event;
    _data_BackgroundColor: THI_Event;
    _event_onResult: THI_Event;
    _prop_FillStyle:boolean;
    _data_Pattern:THI_Event;
    _prop_Style: TBrushStyle;
    
    constructor Create;
    destructor Destroy; override;
    procedure _work_doRotate(var _Data: TData; Index: Word);
    procedure _work_doFlipVertical(var _Data: TData; Index: Word);
    procedure _work_doFlipHorizontal(var _Data: TData; Index: Word);
    procedure _var_Width(var _Data: TData; Index: Word);
    procedure _var_Height(var _Data: TData; Index: Word);
    procedure _var_Result(var _Data: TData; Index: Word);  
	procedure _work_doStyle(var _Data:TData; Index:word);
	procedure _work_doFillStyle(var _Data:TData; Index:word);
	    
  end;
implementation

constructor THIImg_Rotate_Ex.Create;
begin
  inherited;
  RotateBmp := NewDIBBitmap(1, 1, pf24bit);
end;

destructor THIImg_Rotate_Ex.Destroy;
begin
  RotateBmp.Free;
  inherited;
end;

procedure THIImg_Rotate_Ex._work_doFillStyle;
begin
   _prop_FillStyle := ReadBool(_Data);
end;

procedure THIImg_Rotate_Ex._work_doStyle;
var
  tmp: Integer;
begin
  tmp := ToInteger(_Data);
  case tmp of
    0: tmp := 1;
    1: tmp := 0;
  end;
  _prop_Style := TBrushStyle(tmp);
end;


procedure THIImg_Rotate_Ex._work_doRotate;
var
  color: integer;
  degree: real;
  cosA, sinA: real;
  topoverh, leftoverh: integer; 
  x, y, H, W: integer;
  br: HBRUSH;
  pen: HPEN;
  Pattern: PBitmap; 
  bgColor,sColor: TColor;
 
          
  {$ifdef F_P} 
  XF: TXForm;
  {$else}
  newx, newy, SizeDstLine: integer;  
  Sor, Des, Des1: PDword;
  {$endif}

begin
  Bitmap := ReadBitmap(_Data, _data_Bitmap, nil);
  if (Bitmap = nil) or Bitmap.Empty then exit;   
  Bitmap.PixelFormat := pf24bit;
//  if Bitmap.HandleType = bmDDB then Bitmap.HandleType := bmDIB;

  degree := ReadReal(_Data, _data_angle, _prop_angle);
  color := ReadInteger(_Data, _data_BackgroundColor, _prop_BackgroundColor);

  while degree >= 360 do degree := degree - 360;
  while degree < 0 do degree := degree + 360;

  case Round(degree) of
      0: RotateBmp.Assign(Bitmap);
     90: begin
           RotateBmp.Assign(Bitmap);
           RotateBmp.RotateRightTrueColor;
         end;
    180: begin
           RotateBmp.Assign(Bitmap);
           RotateBmp.RotateRightTrueColor;
           RotateBmp.RotateRightTrueColor;
         end;
    270: begin
           RotateBmp.Assign(Bitmap);
           RotateBmp.RotateLeftTrueColor;
         end
    else
    begin
      H := Bitmap.Height;
      W := Bitmap.Width;
      cosA := cos(degree*Pi/180);
      sinA := sin(degree*Pi/180);

      if (degree <= 90) then
      begin 
        topoverh  := 0; 
        y := Round(W * sinA + H * cosA); 
        leftoverh := Round(- H * sinA);
        x := Round(W * cosA) + Abs(leftoverh);
      end
      else if (degree <= 180) then
      begin 
        topoverh  := Round(H * cosA); 
        y := Round(W * sinA) + Abs(topoverh); 
        leftoverh := Round(W * cosA - H * sinA);
        x := Abs(leftoverh);
      end
      else if (degree <= 270) then
      begin 
        topoverh  := Round(W * sinA + H * cosA); 
        y := Abs(topoverh); 
        leftoverh := Round(W * cosA);
        x := Round(- H * sinA) + Abs(leftoverh);
      end
      else
      begin 
        topoverh  := Round(W * sinA); 
        y := Round(H * cosA) + Abs(topoverh); 
        leftoverh := 0;
        x := Round(W * cosA - H * sinA) + Abs(leftoverh);
      end;
		
     
		if Assigned(RotateBmp) then RotateBmp.free; 
      RotateBmp := NewDIBBitmap(x, y{$ifndef F_P} + 2{$endif}, pf24bit);
      pDC := RotateBmp.Canvas.handle;
      RotateBmp.Canvas.Brush.Color := Color;
      FillRect(pDC, RotateBmp.BoundsRect, RotateBmp.Canvas.Brush.Handle);
      
      
    //  mod by Aziz (18.4.2023)
   if _prop_FillStyle then
   begin
     Pattern := ReadBitmap(_Data,_data_Pattern);
     if not Assigned(Pattern) or Pattern.Empty then
       br := GetStockObject(NULL_BRUSH)
     else
       br := CreatePatternBrush(Pattern.Handle);
       SelectObject(pDC,br);                    
       PatBlt(pDC,0,0,1000,1000,PATCOPY);
   end
   else
   begin
   sColor := Color2RGB(ReadInteger(_Data,_data_Color,_prop_Color));
   bgColor := Color2RGB(ReadInteger(_Data,_data_BackgroundColor,_prop_BackgroundColor));
     if _prop_Style = bsSolid then
        br := CreateSolidBrush(sColor)
     else if _prop_Style = bsClear then 
     begin
        br := GetStockObject(NULL_BRUSH);
        SelectObject(pDC,br);
     end   
        else
       begin
        // SetBkMode(pDC, TRANSPARENT);    // TRANSPARENT Opaque 
         SetBkColor(pDC, bgColor);
         br := CreateHatchBrush(ord(_prop_Style) - 2, sColor);   
              
       end;

   end;   
      
       
       
       SelectObject(pDC,br);
       PatBlt(pDC,0,0,1000,1000,PATCOPY); 
       DeleteObject(br);
          
//end of mod by Aziz (18.4.2023)

      {$ifdef F_P}
      SetGraphicsMode(RotateBmp.Canvas.handle,GM_ADVANCED);
      XF.eM11:= CosA;
      XF.eM12:= SinA;
      XF.eM21:= -SinA;
      XF.eM22:= CosA;
      XF.eDx:= -leftoverh;
      XF.eDy:= -topoverh;
      SetWorldTransform(RotateBmp.Canvas.handle, XF);
      Bitmap.Draw(RotateBmp.Canvas.handle, 0, 0);
      {$else}
      Des  := RotateBmp.ScanLine[0];
      Des1 := RotateBmp.ScanLine[1];
      SizeDstLine := Integer(Des) - Integer(Des1);

      for y := 0 to H - 1 do
      begin
        Sor := Bitmap.ScanLine[y];
        for x := 0 to W - 1 do
        begin
          newX := Round(x * cosA - y * sinA - leftoverh) * 3; 
          newY := Round(x * sinA + y * cosA - topoverh);
          Des := RotateBmp.ScanLine[newY];
          inc(PByte(Des), newx);
          Des^ := (Des^ and $FF000000) or (Sor^ and $00FFFFFF);
          Dec(PByte(Des), SizeDstLine);
          Des^ := (Des^ and $FF000000) or (Sor^ and $00FFFFFF);
          Inc(PByte(Sor), 3);
        end;
      end;
      {$endif}  
    end;
  end;
  

       

  _hi_OnEvent(_event_onResult, RotateBmp);
 
end;

procedure THIImg_Rotate_Ex._work_doFlipVertical;
begin
  Bitmap := ReadBitmap(_Data, _data_Bitmap, nil);
  if (Bitmap = nil) or Bitmap.Empty then exit;   
  Bitmap.PixelFormat := pf24bit;
  if Bitmap.HandleType = bmDDB then Bitmap.HandleType := bmDIB;
  RotateBmp.Assign(Bitmap);
  RotateBmp.FlipVertical;
  _hi_onEvent(_event_onResult, RotateBmp);
end;

procedure THIImg_Rotate_Ex._work_doFlipHorizontal;
begin
  Bitmap := ReadBitmap(_Data, _data_Bitmap, nil);
  if (Bitmap = nil) or Bitmap.Empty then exit;   
  Bitmap.PixelFormat := pf24bit;
  if Bitmap.HandleType = bmDDB then Bitmap.HandleType := bmDIB;
  RotateBmp.Assign(Bitmap);
  RotateBmp.FlipHorizontal;
  _hi_onEvent(_event_onResult, RotateBmp);
end;

procedure THIImg_Rotate_Ex._var_Width;
begin
  dtInteger(_Data, RotateBmp.Width);
end;

procedure THIImg_Rotate_Ex._var_Height;
begin
  dtInteger(_Data, RotateBmp.Height);
end;

procedure THIImg_Rotate_Ex._var_Result;
begin
  dtBitmap(_Data, RotateBmp);
end;

end.